import ui
from logHandler import log
import os.path
import wx
import gui
from langslist import langslist
import langslist as lngModule
import globalVars
import config
import _config
import addonHandler
from copy import deepcopy

import sys
impPath = os.path.abspath(os.path.dirname(__file__))
sys.path.append(impPath)
import urllib2
import json
del sys.path[-1]

_config.load()

class JGTLoginDialog(gui.SettingsDialog):
	# Translators: name of the dialog.
	title = _("Login to the JGT service")

	def __init__(self, parent, sessionHolder):
		super(JGTLoginDialog, self).__init__(parent)
		self.sessionHolder = sessionHolder

	def makeSettings(self, sizer):
		# Translators: Help message for a dialog.
		helpLabel = wx.StaticText(self, label=_("Enter your username and password for JGT:"))
		helpLabel.Wrap(self.GetSize()[0])
		sizer.Add(helpLabel)
		userSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		userLabel = wx.StaticText(self, label=_("Username:"))
		userSizer.Add(userLabel)
		self._userText = wx.TextCtrl(self)
		self._userText.SetValue(_config.JGTConfig['settings']['username'])
		userSizer.Add(self._userText)
		passSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		passLabel = wx.StaticText(self, label=_("Password:"))
		passSizer.Add(passLabel)
		self._passText = wx.TextCtrl(self, style=wx.TE_PASSWORD)
		passSizer.Add(self._passText)
		sizer.Add(userSizer)
		sizer.Add(passSizer)

	def postInit(self):
		self._userText.SetFocus()

	def onOk(self, event):
		# attempt to login
		user = self._userText.GetValue()
		_config.JGTConfig['settings']['username'] = user
		_config.save()
		# pass is a python keyword so we had to rename this variable
		password = self._passText.GetValue()
		# build the request url
		urlTemplate = 'https://BlindGamers.com/api/login1?u={user}&p={password}&v={version}'
		# if having a problem with the SSL certificate you can use this url instead
		#urlTemplate = 'http://BlindAudioGames.com/api/login1?u={user}&p={password}&v={version}'
		#urlTemplate = 'http://localhost:55255/api/login1?u={user}&p={password}&v={version}'
		user = urllib2.quote(user.encode('utf-8'))
		password = urllib2.quote(password.encode('utf-8'))
		version = urllib2.quote("JGT 2.0")
		url = urlTemplate.format(user=user, password=password, version=version)
		try:
			data = json.load(urllib2.urlopen(url))
			error = data[0]
			if error != "":
				gui.messageBox(error,_("Error"),style=wx.OK | wx.ICON_ERROR)
			self.sessionHolder.sessionID = data[1]
			ourVersion = "2.1"
			latestJGTVersion = data[2]
			if latestJGTVersion != ourVersion:
				gui.messageBox("You are not using the latest JGT version, you should consider downloading a new version from BlindGamers.com","",style=wx.OK | wx.ICON_ERROR)
		except Exception as e:
			# get the message from the exception
			msg = str(e)
			gui.messageBox(msg, _("Error"),style=wx.OK | wx.ICON_ERROR)
		# needed to run the super class version last, because NVDA 2018.2 disposes the _userText control before I can get the value from it.
		super(JGTLoginDialog, self).onOk(event)
